//+------------------------------------------------------------------+
//|                                                  TestButtons.mq5 |
//|            Copyright 2013, https://login.mql5.com/ru/users/tol64 |
//|                                  Site, http://tol64.blogspot.com |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2013, http://tol64.blogspot.com"
#property link        "http://tol64.blogspot.com"
#property description "email: hello.tol64@gmail.com"
#property version     "1.0"
//---
#property indicator_separate_window //   
#property indicator_plots 0         //   
//---

#define NUMBER_BUTTONS_WIDTH  4     //    
#define NUMBER_BUTTONS_HEIGHT 10     //    

//---   
input string          InpFile="\\Images\\dollar.bmp"; //    
input int             InpWidth=24;                    // X-  
input int             InpHeight=24;                   // Y-  
input int             InpXOffset=4;                   //     X
input int             InpYOffset=4;                   //     Y
input color           InpColor=clrRed;                //    
input ENUM_LINE_STYLE InpStyle=STYLE_SOLID;           //    
input int             InpPointWidth=1;                //    
input bool            InpBack=false;                  //    
input bool            InpSelection=false;             //   
input bool            InpHidden=true;                 //    
input long            InpZOrder=0;                    //    

//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
//--- 
string            font_name="Calibri";
//---   
int               number_subwindow      =WRONG_VALUE;             //  
int               subwindow_height      =0;                       //  
string            shortname_subwindow   ="TestButtons";           //   
string            prefix                =shortname_subwindow+"_"; //   
int               chart_width           =0;                       //  
int               chart_height          =0;                       //  
int               chart_y_distance      =0;                       //      
//---  
color             button_bg_color       =clrSteelBlue;            //  
color             button_font_color     =clrWhite;                //  
color             button_hover_bg_color =C'38,118,166';           //     
color             button_on_bg_color    =C'2,72,136';             //   
//+------------------------------------------------------------------+
//|                                                           |
//+------------------------------------------------------------------+
//---    
string buttons_text[NUMBER_BUTTONS_HEIGHT][NUMBER_BUTTONS_WIDTH]=
  {

     {"BUTTON 01","BUTTON 02","BUTTON 03","BUTTON 04"},
     {"BUTTON 05","BUTTON 06","BUTTON 07","BUTTON 08"},
     {"BUTTON 09","BUTTON 10","BUTTON 11","BUTTON 12"},
     {"BUTTON 13","BUTTON 14","BUTTON 15","BUTTON 16"},
     {"BUTTON 13","BUTTON 14","BUTTON 15","BUTTON 16"},
     {"BUTTON 13","BUTTON 14","BUTTON 15","BUTTON 16"},
     {"BUTTON 13","BUTTON 14","BUTTON 15","BUTTON 16"},
     {"BUTTON 13","BUTTON 14","BUTTON 15","BUTTON 16"},
     {"BUTTON 13","BUTTON 14","BUTTON 15","BUTTON 16"},
     {"BUTTON 13","BUTTON 14","BUTTON 15","BUTTON 16"}

  };
/*
  //---  o   
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
         buttons_text[j][i]="BUTTON "+buttons_text[j][i];  
*/
//---  
string buttons_object_name[NUMBER_BUTTONS_HEIGHT][NUMBER_BUTTONS_WIDTH]=
  {
     {"button_01","button_02","button_03","button_04"},
     {"button_05","button_06","button_07","button_08"},
     {"button_09","button_10","button_11","button_12"},
     {"button_13","button_14","button_15","button_16"},
     {"button_17","button_18","button_19","button_20"},
     {"button_21","button_22","button_23","button_24"},
     {"button_25","button_26","button_27","button_28"},
     {"button_29","button_30","button_31","button_32"},
     {"button_33","button_34","button_35","button_36"},
     {"button_37","button_38","button_39","button_40"}

  };
/*           //---   
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
         buttons_object_name[j][i]="button_"+buttons_object_name[j][i];

*/

//---  
int buttons_width[NUMBER_BUTTONS_HEIGHT][NUMBER_BUTTONS_WIDTH];
//---  
int buttons_height[NUMBER_BUTTONS_HEIGHT][NUMBER_BUTTONS_WIDTH];
//---  X
int buttons_x_distance[NUMBER_BUTTONS_HEIGHT][NUMBER_BUTTONS_WIDTH];
//---  Y
int buttons_y_distance[NUMBER_BUTTONS_HEIGHT][NUMBER_BUTTONS_WIDTH];
//---  
bool buttons_state[NUMBER_BUTTONS_HEIGHT][NUMBER_BUTTONS_WIDTH]=
  {
     {true,false,false,false},
     {false,false,false,false},
     {false,false,false,false},
     {false,false,false,false}
  };
//---  
color buttons_color[NUMBER_BUTTONS_HEIGHT][NUMBER_BUTTONS_WIDTH];
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
bool BitmapCreate(const long            chart_ID=0,        // ID 
                  const string          name="Bitmap",     //  
                  const int             sub_window=0,      //  
                  datetime              time=0,            //   
                  double                price=0,           //   
                  const string          file="",           //    
                  const int             width=10,          // X-  
                  const int             height=10,         // Y-  
                  const int             x_offset=0,        //     X
                  const int             y_offset=0,        //     Y
                  const color           clr=clrRed,        //    
                  const ENUM_LINE_STYLE style=STYLE_SOLID, //    
                  const int             point_width=1,     //   
                  const bool            back=false,        //   
                  const bool            selection=false,   //   
                  const bool            hidden=true,       //    
                  const long            z_order=0)         //    
  {
//---    ,    
   ChangeBitmapEmptyPoint(time,price);
//---   
   ResetLastError();
//---  
   if(!ObjectCreate(chart_ID,name,OBJ_BITMAP,sub_window,time,price))
     {
      Print(__FUNCTION__,
            ":       !   = ",GetLastError());
      return(false);
     }
//---      
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,file))
     {
      Print(__FUNCTION__,
            ":    !   = ",GetLastError());
      return(false);
     }
//---    ;     
//---      ()  , 
//---   ;        ,
//---     ,    
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//--- ,        
//---       ;  
//---          
   ObjectSetInteger(chart_ID,name,OBJPROP_XOFFSET,x_offset);
   ObjectSetInteger(chart_ID,name,OBJPROP_YOFFSET,y_offset);
//---        
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,point_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                  |
//|                                  |
//+------------------------------------------------------------------+
void ChangeBitmapEmptyPoint(datetime &time,double &price)
  {
//---     ,      
   if(!time)
      time=TimeCurrent();
//---     ,      Bid
   if(!price)
      price=SymbolInfoDouble(Symbol(),SYMBOL_BID);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---     1 
   EventSetTimer(1);
//---     
   AddPrefix();
//---     
   ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,true);
//---   
   IndicatorSetString(INDICATOR_SHORTNAME,shortname_subwindow);
//---   
   SetSubwindowProperties();
//---   
   InitButtonsColor();       //  
   InitButtonsXYdistance();  //  
   InitButtonsWidthHeight(); //  
//---   
   SetButtonsPanel();
//---  
   ChartRedraw();
//---   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if(reason==REASON_REMOVE ||  //      
      reason==REASON_RECOMPILE) //   
     {
      //---  
      EventKillTimer();
      //---  
      DeleteButtons();
      //---    
      ChartSetInteger(0,CHART_MOUSE_SCROLL,true);
      //---     
      ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,false);
      //---  
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int    rates_total,     //   price[]
                const int    prev_calculated, //     
                const int    begin,           //    
                const double &price[])        //   
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//--- ,     
   CheckEventMouseMove();
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int    id,
                  const long   &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---        
   if(id==CHARTEVENT_MOUSE_MOVE)
     {
      int      x      =(int)lparam; //  
      int      y      =(int)dparam; //  
      int      window =WRONG_VALUE; // ,    
      datetime time   =NULL;        //  ,  
      double   level  =0.0;         //  (),  
      //---   
      if(ChartXYToTimePrice(0,x,y,window,time,level))
        {
         //---        
         chart_y_distance=(int)ChartGetInteger(0,CHART_WINDOW_YDISTANCE,number_subwindow);
         //---   Y  
         y-=chart_y_distance;
         //---     ,
         //      
         if(window==number_subwindow)
            ChartSetInteger(0,CHART_MOUSE_SCROLL,false);
         //---   ,      
         else
            ChartSetInteger(0,CHART_MOUSE_SCROLL,true);
         //---
         ChangeButtonsColorHover(x,y);
        }
      //---  
      ChartRedraw(); return;
     }
//---        
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      //---    
      if(InitButtonsState(sparam))
        {
         //---   
         ChangeColorOnButtons();

         //---  

         ChangePictureOnButtons();
        }
      //---  
      ChartRedraw(); return;
     }
//---       
   if(id==CHARTEVENT_CHART_CHANGE)
     {
      //--- ,     
      CheckEventMouseMove();
      //---   
      SetSubwindowProperties();
      //---    
      InitButtonsXYdistance();
      //---   
      InitButtonsWidthHeight();
      //---    
      SetXYdistanceButtons();
      //---    
      ResizeButtons();
      //---  
      ChartRedraw(); return;
     }
  }
//+------------------------------------------------------------------+
//| ,                      |
//+------------------------------------------------------------------+
void CheckEventMouseMove()
  {
//---     ,   
   if(!ChartGetInteger(0,CHART_EVENT_MOUSE_MOVE))
      ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,true);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
void AddPrefix()
  {
//---    
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
         buttons_object_name[j][i]=prefix+buttons_object_name[j][i];
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
void ChangeButtonsColorHover(int x,int y)
  {
   int x1,y1,x2,y2;
//---    XY  
   InitButtonsXYdistance();
//--- ,       
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
     {
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
        {
         //---    ,
         //      
         if(buttons_state[j][i])
            continue;
         //---   
         x1=buttons_x_distance[j][i];
         y1=buttons_y_distance[j][i];
         x2=buttons_x_distance[j][i]+buttons_width[j][i];
         y2=buttons_y_distance[j][i]+buttons_height[j][i];
         //---      ,
         //       
         if(x>x1 && x<x2 && y>y1 && y<y2)
            ObjectSetInteger(0,buttons_object_name[j][i],OBJPROP_BGCOLOR,button_hover_bg_color);
         //---    
         else
            ObjectSetInteger(0,buttons_object_name[j][i],OBJPROP_BGCOLOR,button_bg_color);
        }
     }
  }
//+------------------------------------------------------------------+
//|   ,          |
//+------------------------------------------------------------------+
bool InitButtonsState(string click_object)
  {
//---    
   number_subwindow=ChartWindowFind(0,shortname_subwindow);
//---          
   if(ObjectFind(0,click_object)==number_subwindow && 
      StringFind(click_object,prefix+"button_",0)>=0)
     {
      //---   
      for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
        {
         for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
           {
            //---    
            if(click_object==buttons_object_name[j][i])
               buttons_state[j][i]=true;
            else
               buttons_state[j][i]=false;
           }
        }
      //---
      return(true);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void ChangePictureOnButtons()
  {

         //---    ,
         //       1 
         if(buttons_state[0][0]==true)
           {
            ObjectsDeleteAll(0,OBJ_BITMAP);
            BitmapCreate(0,"Bitmap1",0,0,High[1],"\\Images\\dollar.bmp",InpWidth,InpHeight,InpXOffset,
                         InpYOffset,InpColor,InpStyle,InpPointWidth,InpBack,InpSelection,InpHidden,InpZOrder);
           }
         //---  2 
         if(buttons_state[0][1]==true)
           {
            ObjectsDeleteAll(0,OBJ_BITMAP);
            BitmapCreate(0,"Bitmap2",0,0,High[1],"\\Images\\euro.bmp",InpWidth,InpHeight,InpXOffset,
                         InpYOffset,InpColor,InpStyle,InpPointWidth,InpBack,InpSelection,InpHidden,InpZOrder);
           }

         //---  3  
         if(buttons_state[0][2]==true)
           {
            ObjectsDeleteAll(0,OBJ_BITMAP);
            BitmapCreate(0,"Bitmap3",0,0,High[1],"\\Images\\boinc32.bmp",InpWidth,InpHeight,InpXOffset,
                         InpYOffset,InpColor,InpStyle,InpPointWidth,InpBack,InpSelection,InpHidden,InpZOrder);
           }

  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void ChangeColorOnButtons()
  {
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
     {
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
        {
         //---    ,
         //       
         if(buttons_state[j][i])
            ObjectSetInteger(0,buttons_object_name[j][i],OBJPROP_BGCOLOR,button_on_bg_color);
         //---      
         else
            ObjectSetInteger(0,buttons_object_name[j][i],OBJPROP_BGCOLOR,button_bg_color);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
void SetSubwindowProperties()
  {
//---    
   number_subwindow=ChartWindowFind(0,shortname_subwindow);
//---     
   chart_width=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS);
   subwindow_height=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,number_subwindow);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void SetButtonsPanel()
  {
//---  
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
     {
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
        {
         CreateEdit(0,number_subwindow,buttons_object_name[j][i],buttons_text[j][i],
                    CORNER_LEFT_UPPER,font_name,8,button_font_color,buttons_color[j][i],clrNONE,
                    buttons_width[j][i],buttons_height[j][i],
                    buttons_x_distance[j][i],buttons_y_distance[j][i],2,true,buttons_text[j][i]);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void InitButtonsColor()
  {
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
     {
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
        {
         //---   
         if(buttons_state[j][i])
            buttons_color[j][i]=button_on_bg_color;
         //---   
         else
            buttons_color[j][i]=button_bg_color;
        }
     }
  }
//+------------------------------------------------------------------+
//|   XY                                |
//+------------------------------------------------------------------+
void InitButtonsXYdistance()
  {
   int button_width=chart_width/NUMBER_BUTTONS_WIDTH;
   int button_height=subwindow_height/NUMBER_BUTTONS_HEIGHT;
//---
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
     {
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
        {
         if(i==0)
            buttons_x_distance[j][i]=0;
         else
            buttons_x_distance[j][i]=(button_width*i)-i;
         //---
         if(j==0)
            buttons_y_distance[j][i]=0;
         else
            buttons_y_distance[j][i]=(button_height*j)-j;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void InitButtonsWidthHeight()
  {
   int button_width=chart_width/NUMBER_BUTTONS_WIDTH;
   int button_height=subwindow_height/NUMBER_BUTTONS_HEIGHT;
//---
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
     {
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
        {
         if(i==NUMBER_BUTTONS_WIDTH-1)
            buttons_width[j][i]=chart_width-(button_width*(NUMBER_BUTTONS_WIDTH-1)-i);
         else
            buttons_width[j][i]=button_width;
         //---
         if(j==NUMBER_BUTTONS_HEIGHT-1)
            buttons_height[j][i]=subwindow_height-(button_height*(NUMBER_BUTTONS_HEIGHT-1)-j)-1;
         else
            buttons_height[j][i]=button_height;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void SetXYdistanceButtons()
  {
//---  
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
     {
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
        {
         ObjectSetInteger(0,buttons_object_name[j][i],OBJPROP_XDISTANCE,buttons_x_distance[j][i]);
         ObjectSetInteger(0,buttons_object_name[j][i],OBJPROP_YDISTANCE,buttons_y_distance[j][i]);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void ResizeButtons()
  {
//---  
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
     {
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
        {
         ObjectSetInteger(0,buttons_object_name[j][i],OBJPROP_XSIZE,buttons_width[j][i]);
         ObjectSetInteger(0,buttons_object_name[j][i],OBJPROP_YSIZE,buttons_height[j][i]);
        }
     }
  }
//+------------------------------------------------------------------+
//| __EDIT                                            |
//+------------------------------------------------------------------+
void CreateEdit(long   chart_id,     // id 
                int    subwindow,    //   ()
                string name,         //  
                string text,         //  
                long   corner,       //  
                string font,         // 
                int    font_size,    //  
                color  font_color,   //  
                color  bg_color,     //  
                color  border_color, //  
                int    x_size,       // 
                int    y_size,       // 
                int    x_dist,       //    X
                int    y_dist,       //    Y
                long   zorder,       // 
                bool   read_only,    //  "  "
                string tooltip)      //  
  {
//---    , ...
   if(ObjectCreate(chart_id,name,OBJ_EDIT,subwindow,0,0))
     {
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);                  //  
      ObjectSetInteger(chart_id,name,OBJPROP_CORNER,corner);             //   
      ObjectSetString(chart_id,name,OBJPROP_FONT,font);                  //  
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,font_size);        //   
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,font_color);          //  
      ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,bg_color);          //  
      ObjectSetInteger(chart_id,name,OBJPROP_BORDER_COLOR,border_color); //  
      ObjectSetInteger(chart_id,name,OBJPROP_XSIZE,x_size);              // 
      ObjectSetInteger(chart_id,name,OBJPROP_YSIZE,y_size);              // 
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x_dist);          //   X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,y_dist);          //   Y
      ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);          //   ,  FALSE
      ObjectSetInteger(chart_id,name,OBJPROP_ZORDER,zorder);             //  /
      ObjectSetInteger(chart_id,name,OBJPROP_READONLY,read_only);        //   
      ObjectSetInteger(chart_id,name,OBJPROP_ALIGN,ALIGN_CENTER);        //   
      ObjectSetString(chart_id,name,OBJPROP_TOOLTIP,tooltip);            //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void DeleteButtons()
  {
   for(int i=0; i<NUMBER_BUTTONS_WIDTH; i++)
      for(int j=0; j<NUMBER_BUTTONS_HEIGHT; j++)
         DeleteObjectByName(buttons_object_name[j][i]);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void DeleteObjectByName(string Name)
  {
//---    
   if(ObjectFind(0,Name)>=0)
     {
      //---     ,   
      if(!ObjectDelete(0,Name))
         Print(" ("+IntegerToString(GetLastError())+")   !");
     }
  }
//+------------------------------------------------------------------+
